using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Runtime.InteropServices;
using System.Diagnostics;
using ClientControls;
using System.Text;

namespace SpringClient
{
	/// <summary>
	/// Summary description for BattleRoom.
	/// </summary>
	public class BattleRoom : System.Windows.Forms.Form
	{
		[DllImport("User32.dll")]
		static extern Int32 SendMessage(IntPtr hWnd, Int32 wMsg, Int32 wParam, Int32 lParam);

		[DllImport("User32.dll")]
		static extern Int32 GetScrollPos(IntPtr hWnd, Int32 nBar);

		[DllImport("User32.dll")]
		static extern Boolean GetScrollRange(IntPtr hWnd, Int32 nBar, ref Int32 lpMinPos,
			ref Int32 lpMaxPos);

		[DllImport(@".\Unitsync.dll")]
		private static extern Int32 GetPrimaryModIndex(string modname);
		[DllImport(@".\Unitsync.dll")]
		private static extern string GetPrimaryModArchive(Int32 index);

		private ClientControls.ListViewEx listViewEx1;
		private System.Windows.Forms.ColumnHeader columnName;
		private System.Windows.Forms.ColumnHeader columnTeam;
		private System.Windows.Forms.ColumnHeader columnReady;
		private System.Windows.Forms.ColumnHeader columnAllyTeam;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private uint			m_ID;
		private bool			m_bHost;
		private int				m_ConnID;
		private bool			m_bSpectator;

		private object			m_Handler = null;
		private int				m_Port;
		private bool			m_Running;

		private MapSelector			m_mapSelector;

		private ConnectionManager	m_ConnectionManager;

		private delegate void delBootUser(BattleStateManager.BattleMemberInfo bmi);

		private delBootUser BootUser;
		/*
		public delegate void delCloseBattleRoom();
		public delegate BattleStateManager.BattleMemberInfo delAddMember(bool spectator, int id, bool self, BattleStateManager.TeamColor teamid, int internalId, string name, string clan);
		public delegate void delChangeTeam(int id, BattleStateManager.TeamColor to);
		public delegate void delChangeAllyTeam(bool self, byte team, byte to);
		public delegate void delRemoveMember(int id);

		public delCloseBattleRoom CloseBattleRoom;
		public delAddMember AddMember;
		public delChangeTeam ChangeTeam;
		public delChangeAllyTeam ChangeAllyTeam;
		public delRemoveMember RemoveMember;
*/
		const int COLNAME = 0;
		const int COLTEAM = 1;
		const int COLALLYTEAM = 2;
		private ClientMain				m_PrimaryForm;
		const int COLREADY = 3;
		private System.Windows.Forms.RichTextBox TypeMessage;
		private System.Windows.Forms.RichTextBox PastMessages;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Splitter splitter2;
		private ClientControls.Minimap Minimap;
		private System.Windows.Forms.Label Mapname;
		private System.Windows.Forms.Button ButtonStart;
		private System.Windows.Forms.ColumnHeader columnAllyState;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuOptions;
		private System.Windows.Forms.MenuItem menuOptionsSide;
		private System.Windows.Forms.Panel panel5;
		private System.Windows.Forms.Panel panel4;
		private System.Windows.Forms.TrackBar MetalBar;
		private System.Windows.Forms.TrackBar EnergyBar;
		private System.Windows.Forms.Label Metal;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TrackBar MaxUnits;
		private System.Windows.Forms.Label MaxUnitsValue;
		private System.Windows.Forms.Label EnergyValue;
		private System.Windows.Forms.Label MetalValue;
		private System.Windows.Forms.Splitter splitter3;
		private System.Windows.Forms.ComboBox StartPosType;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ContextMenu BootPopup;
		private System.Windows.Forms.MenuItem menuItemBoot;

		public BattleStateManager	m_BattleStateManager;

		private byte m_MaxPlayers = 0;
		private System.Windows.Forms.ColumnHeader ColumnSync;
		private System.Windows.Forms.ListBox listBoxDisabled;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.ComboBox GameEndType;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.MenuItem HostOptions;
		private System.Windows.Forms.MenuItem menuBoot;

		private string Password = "";

		public bool Running
		{
			get
			{
				return m_Running;
			}
		}

		public string SMapName
		{
			get
			{
				return Mapname.Text;
			}
		}

		public BattleRoom(ClientMain parentForm, uint ID, int port, bool host, bool spectator, ConnectionManager cm, int intID, byte maxplayers,string modname)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			m_Running = false;

			BootUser = new delBootUser(BootUserHelper);
			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			// USE A CHECKED LIST BOX FOR ALLY TEAMS

			try
			{
				if ( host )
				{
					m_MaxPlayers = maxplayers;
					this.Minimap.Click += new System.EventHandler(this.Minimap_Click);
					m_BattleStateManager = new BattleStateManager(listViewEx1, ButtonStart, menuOptions);
					m_mapSelector = new MapSelector(Minimap, Mapname);
					Minimap.ImageChanged += new ClientControls.Minimap.delImageChanged(Minimap_ImageChanged);
				}
				else
					m_BattleStateManager = new BattleStateManager(listViewEx1, null, menuOptions);

				listViewEx1.SmallImageList = new ImageList();
				listViewEx1.SmallImageList.ImageSize = new Size(25, 25);
				listViewEx1.SmallImageList.Images.Add(new Bitmap("bitmaps\\arm1.gif"));
				listViewEx1.SmallImageList.Images.Add(new Bitmap("bitmaps\\core1.gif"));
				listViewEx1.SmallImageList.Images.Add(new Bitmap("bitmaps\\spectator.gif"));

				m_ID = ID;
				m_bHost = host;
				m_Port = port;
				m_ConnectionManager = cm;
				m_PrimaryForm = parentForm;
				m_ConnID = intID;
				m_bSpectator = spectator;

				Text = Text + " - " + UserInfo.Name;

				if ( host )
				{
					m_BattleStateManager.Clear(true);
					BattleStateManager.BattleMemberInfo bmi = m_BattleStateManager.AddMember(spectator, m_ConnID, true, (BattleStateManager.TeamColor)0, -1, 
						UserInfo.Name, UserInfo.Clan, 0);
					if ( !spectator )
					{
						ComboBox cb = (ComboBox)listViewEx1.GetEmbeddedControl(1, 0);
						cb.Enabled = true;
					}
					Text += " (Host)";
					m_ConnID = 0;
				}
				else
				{
					Text += " (Client)";
				}
				Text+= " "+modname;
				Global.SelectedMod=modname;
				if(host)
				{
					StartPosType.Items.Add("In order");
					StartPosType.Items.Add("Random order");
					StartPosType.Items.Add("Choose in game");

					GameEndType.Items.Add("Cmd continue");
					GameEndType.Items.Add("Cmd ends");
				} 
				else 
				{
					StartPosType.Enabled=false;
					GameEndType.Enabled=false;

					HostOptions.Enabled=false;
				}

			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		public int GetID()
		{
			return m_ConnID;
		}

/*
		public void SetID(int id)
		{
			m_ConnID = id;
		}
*/
		public void SetPassword(string password)
		{
			Password = password;
			if ( m_bHost )
			{
				BattleServer bs = (BattleServer)m_Handler;
				bs.SetPassword(password);
			}
		}

		public void SetMap(string filename, string mapname)
		{
			try
			{
				this.Minimap.CloseImage();
				this.Minimap.Open(filename);
				Mapname.Text = mapname;
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void RemoveMember( int id )
		{
			m_BattleStateManager.RemoveMember(id);
		}

		public void ChangeTeam(int ID, BattleStateManager.TeamColor to)
		{
			try
			{
				if ( m_bHost )
				{
					// then send everyone the message
					BattleServer bs = (BattleServer)this.m_Handler;
					bs.SendChangeTeamMessage(ID, to);
				}
				if ( ID == m_ConnID && !m_bHost )
				{
					// then send the server the message
					BattleClient bc = (BattleClient)this.m_Handler;
					bc.SendChangeTeamMessage(to);
				}
	//			if ( ID != m_ConnID )
					m_BattleStateManager.MemberChangeTeam(ID, (byte)to, 0xFF);
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		public void ChangeReady( bool self, int id, bool isReady )
		{
			try
			{
				if ( m_bHost )
				{
					// then send everyone the message
					BattleServer bs = (BattleServer)this.m_Handler;
					bs.SendReadyState(id, isReady);
				}
				if ( self & !m_bHost )
				{
					// then send the server the message
					BattleClient bc = (BattleClient)this.m_Handler;
					bc.SendReadyState(isReady);
				}
				if ( !self )
				{
					if ( isReady )
						m_BattleStateManager.SetReady(id);
					else
						m_BattleStateManager.SetNotReady(id);
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		public void SendChangeSide(byte team, byte to)
		{
			try
			{
				if ( m_bHost )
				{
					BattleServer bs = (BattleServer)m_Handler;
					bs.SendChangeSide(team, to);
				}
				else
				{
					BattleClient bc = (BattleClient)m_Handler;
					bc.SendChangeSide(to);
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		public void Changeside(byte team, byte to)
		{
			m_BattleStateManager.TeamChangeSide(team, to);
		}

		public void SendAllyMessage(byte lhs, byte rhs)
		{
			try
			{
				if ( m_bHost )
				{
					BattleServer bs = (BattleServer)m_Handler;
					bs.SendAlliance(lhs, rhs);
					m_BattleStateManager.AddAlliance(lhs, rhs);
				}
				else
				{
					BattleClient bc = (BattleClient)m_Handler;
					bc.SendAlliance(rhs);
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		public void SendRemoveAllyMessage(byte lhs, byte rhs)
		{
			try
			{
				if ( m_bHost )
				{
					BattleServer bs = (BattleServer)m_Handler;
					bs.SendRemoveAlliance(lhs, rhs);
					m_BattleStateManager.RemoveAlliance(lhs, rhs);
				}
				else
				{
					BattleClient bc = (BattleClient)m_Handler;
					bc.SendRemoveAlliance(rhs);
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		public void AddAlliance(byte lhs, byte rhs)
		{
			m_BattleStateManager.AddAlliance(lhs, rhs);
		}

		public void RemoveAlliance( byte lhs, byte rhs )
		{
			m_BattleStateManager.RemoveAlliance(lhs, rhs);
		}

		public void ChangeAllyTeam(bool self, byte team, byte to)
		{
			try
			{
				if ( m_bHost )
				{
					// then send everyone the message
					BattleServer bs = (BattleServer)this.m_Handler;
					bs.SendChangeAllyTeamMessage(team, to);
				}
				if ( self && !m_bHost )//ID == UserInfo.ID )
				{
					// then send the server the message
					BattleClient bc = (BattleClient)this.m_Handler;
					bc.SendChangeAllyTeamMessage(to);
				}
				m_BattleStateManager.TeamChangeAllyTeam((byte)team, (byte)to);
				/*
				if ( !self )
				{
						// need to get what team the user is on
					//	BattleStateManager.TeamColor team = m_BattleStateManager.GetUserTeam(ID);
					m_BattleStateManager.TeamChangeAllyTeam((byte)team, (byte)to);
				}*/
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		public void ChangeResources(bool self,int metal,int energy)
		{
			try
			{
				if ( self )//ID == UserInfo.ID )
				{
					if ( m_bHost )
					{
						// then send everyone the message
						BattleServer bs = (BattleServer)this.m_Handler;
						bs.SendChangeResourcesMessage(m_ConnID, metal,energy);
						m_BattleStateManager.metal=metal;
						m_BattleStateManager.energy=energy;
					}
				}
				else
				{
					MetalBar.Value=metal;
					EnergyBar.Value=energy;
					m_BattleStateManager.metal=metal;
					m_BattleStateManager.energy=energy;
					MetalValue.Text=Convert.ToString(MetalBar.Value);
					EnergyValue.Text=Convert.ToString(EnergyBar.Value);
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		public void ChangeMaxUnits(bool self,int maxUnits)
		{
			try
			{
				if ( self )//ID == UserInfo.ID )
				{
					if ( m_bHost )
					{
						// then send everyone the message
						BattleServer bs = (BattleServer)this.m_Handler;
						bs.SendChangeMaxUnitsMessage(m_ConnID, maxUnits);
						m_BattleStateManager.maxUnits=maxUnits;
					}
				}
				else
				{
					MaxUnits.Value=maxUnits;
					m_BattleStateManager.maxUnits=maxUnits;
					MaxUnitsValue.Text=Convert.ToString(MaxUnits.Value);
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		public void ChangeStartPosType(bool self,int type)
		{
			try
			{
				if ( self )//ID == UserInfo.ID )
				{
					if ( m_bHost )
					{
						// then send everyone the message
						BattleServer bs = (BattleServer)this.m_Handler;
						bs.SendChangeStartPosTypeMessage(m_ConnID, type);
						m_BattleStateManager.startPosType=type;
					}
				}
				else
				{
					m_BattleStateManager.startPosType=type;
					switch(type)
					{
						case 0:
							StartPosType.Text="In order";
							break;
						case 1:
							StartPosType.Text="Random order";
							break;
						case 2:
							StartPosType.Text="Choose in game";
							break;
						default:
							StartPosType.Text="Unknown start pos type";
							break;
					}
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		public void ChangeGoalType(bool self,int type)
		{
			try
			{
				if ( self )//ID == UserInfo.ID )
				{
					if ( m_bHost )
					{
						// then send everyone the message
						BattleServer bs = (BattleServer)this.m_Handler;
						bs.SendChangeGameGoalTypeMessage(m_ConnID, type);
						m_BattleStateManager.gameGoalType=type;
					}
				}
				else
				{
					//MessageBox.Show(string.Format("GameMode {0}",type.ToString()));
					m_BattleStateManager.gameGoalType=type;
					switch(type)
					{
						case 0:
							GameEndType.Text="Cmd continue";
							break;
						case 1:
							GameEndType.Text="Cmd ends";
							break;
						default:
							GameEndType.Text="Unknown";
							break;
					}
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		public BattleStateManager.BattleMemberInfo AddMember(bool spectator, int id, bool self, BattleStateManager.TeamColor teamid, int internalId, string name, string clan, byte ready)
		{
			return m_BattleStateManager.AddMember(spectator, id, self, teamid, internalId, name, clan, ready);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(BattleRoom));
			this.listViewEx1 = new ClientControls.ListViewEx();
			this.columnName = new System.Windows.Forms.ColumnHeader();
			this.columnTeam = new System.Windows.Forms.ColumnHeader();
			this.columnAllyTeam = new System.Windows.Forms.ColumnHeader();
			this.columnAllyState = new System.Windows.Forms.ColumnHeader();
			this.columnReady = new System.Windows.Forms.ColumnHeader();
			this.ColumnSync = new System.Windows.Forms.ColumnHeader();
			this.TypeMessage = new System.Windows.Forms.RichTextBox();
			this.PastMessages = new System.Windows.Forms.RichTextBox();
			this.panel3 = new System.Windows.Forms.Panel();
			this.GameEndType = new System.Windows.Forms.ComboBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.listBoxDisabled = new System.Windows.Forms.ListBox();
			this.label2 = new System.Windows.Forms.Label();
			this.StartPosType = new System.Windows.Forms.ComboBox();
			this.MaxUnitsValue = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.MaxUnits = new System.Windows.Forms.TrackBar();
			this.EnergyValue = new System.Windows.Forms.Label();
			this.MetalValue = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.Metal = new System.Windows.Forms.Label();
			this.EnergyBar = new System.Windows.Forms.TrackBar();
			this.MetalBar = new System.Windows.Forms.TrackBar();
			this.ButtonStart = new System.Windows.Forms.Button();
			this.Mapname = new System.Windows.Forms.Label();
			this.Minimap = new ClientControls.Minimap();
			this.panel4 = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panel5 = new System.Windows.Forms.Panel();
			this.splitter3 = new System.Windows.Forms.Splitter();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuOptions = new System.Windows.Forms.MenuItem();
			this.menuOptionsSide = new System.Windows.Forms.MenuItem();
			this.BootPopup = new System.Windows.Forms.ContextMenu();
			this.menuItemBoot = new System.Windows.Forms.MenuItem();
			this.HostOptions = new System.Windows.Forms.MenuItem();
			this.menuBoot = new System.Windows.Forms.MenuItem();
			this.panel3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.MaxUnits)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.EnergyBar)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.MetalBar)).BeginInit();
			this.panel4.SuspendLayout();
			this.panel5.SuspendLayout();
			this.SuspendLayout();
			// 
			// listViewEx1
			// 
			this.listViewEx1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																																									this.columnName,
																																									this.columnTeam,
																																									this.columnAllyTeam,
																																									this.columnAllyState,
																																									this.columnReady,
																																									this.ColumnSync});
			this.listViewEx1.Dock = System.Windows.Forms.DockStyle.Top;
			this.listViewEx1.Location = new System.Drawing.Point(0, 0);
			this.listViewEx1.MultiSelect = false;
			this.listViewEx1.Name = "listViewEx1";
			this.listViewEx1.Size = new System.Drawing.Size(387, 192);
			this.listViewEx1.TabIndex = 0;
			this.listViewEx1.View = System.Windows.Forms.View.Details;
			// 
			// columnName
			// 
			this.columnName.Text = "Name";
			this.columnName.Width = 120;
			// 
			// columnTeam
			// 
			this.columnTeam.Text = "Team";
			this.columnTeam.Width = 50;
			// 
			// columnAllyTeam
			// 
			this.columnAllyTeam.Text = "Ally Team";
			// 
			// columnAllyState
			// 
			this.columnAllyState.Text = "Ally State";
			// 
			// columnReady
			// 
			this.columnReady.Text = "Ready";
			this.columnReady.Width = 50;
			// 
			// ColumnSync
			// 
			this.ColumnSync.Text = "Sync";
			this.ColumnSync.Width = 40;
			// 
			// TypeMessage
			// 
			this.TypeMessage.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.TypeMessage.Location = new System.Drawing.Point(0, 345);
			this.TypeMessage.Name = "TypeMessage";
			this.TypeMessage.Size = new System.Drawing.Size(387, 48);
			this.TypeMessage.TabIndex = 2;
			this.TypeMessage.Text = "";
			this.TypeMessage.KeyDown += new System.Windows.Forms.KeyEventHandler(this.TypeMessage_KeyDown);
			// 
			// PastMessages
			// 
			this.PastMessages.Dock = System.Windows.Forms.DockStyle.Fill;
			this.PastMessages.Location = new System.Drawing.Point(0, 0);
			this.PastMessages.Name = "PastMessages";
			this.PastMessages.ReadOnly = true;
			this.PastMessages.Size = new System.Drawing.Size(387, 345);
			this.PastMessages.TabIndex = 0;
			this.PastMessages.Text = "";
			// 
			// panel3
			// 
			this.panel3.Controls.Add(this.GameEndType);
			this.panel3.Controls.Add(this.label4);
			this.panel3.Controls.Add(this.label3);
			this.panel3.Controls.Add(this.listBoxDisabled);
			this.panel3.Controls.Add(this.label2);
			this.panel3.Controls.Add(this.StartPosType);
			this.panel3.Controls.Add(this.MaxUnitsValue);
			this.panel3.Controls.Add(this.label5);
			this.panel3.Controls.Add(this.MaxUnits);
			this.panel3.Controls.Add(this.EnergyValue);
			this.panel3.Controls.Add(this.MetalValue);
			this.panel3.Controls.Add(this.label1);
			this.panel3.Controls.Add(this.Metal);
			this.panel3.Controls.Add(this.EnergyBar);
			this.panel3.Controls.Add(this.MetalBar);
			this.panel3.Controls.Add(this.ButtonStart);
			this.panel3.Controls.Add(this.Mapname);
			this.panel3.Controls.Add(this.Minimap);
			this.panel3.Dock = System.Windows.Forms.DockStyle.Right;
			this.panel3.Location = new System.Drawing.Point(390, 0);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(250, 585);
			this.panel3.TabIndex = 4;
			this.panel3.Paint += new System.Windows.Forms.PaintEventHandler(this.panel3_Paint);
			// 
			// GameEndType
			// 
			this.GameEndType.Location = new System.Drawing.Point(72, 328);
			this.GameEndType.Name = "GameEndType";
			this.GameEndType.Size = new System.Drawing.Size(168, 21);
			this.GameEndType.TabIndex = 16;
			this.GameEndType.Text = "Cmd continue";
			this.GameEndType.SelectedIndexChanged += new System.EventHandler(this.GameEndType_SelectedIndexChanged);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 328);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(72, 16);
			this.label4.TabIndex = 17;
			this.label4.Text = "Game mode";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(72, 360);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(100, 16);
			this.label3.TabIndex = 15;
			this.label3.Text = "Disabled Units";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// listBoxDisabled
			// 
			this.listBoxDisabled.HorizontalScrollbar = true;
			this.listBoxDisabled.Location = new System.Drawing.Point(8, 384);
			this.listBoxDisabled.Name = "listBoxDisabled";
			this.listBoxDisabled.Size = new System.Drawing.Size(232, 95);
			this.listBoxDisabled.TabIndex = 14;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 296);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 16);
			this.label2.TabIndex = 13;
			this.label2.Text = "Start pos";
			// 
			// StartPosType
			// 
			this.StartPosType.Location = new System.Drawing.Point(72, 296);
			this.StartPosType.Name = "StartPosType";
			this.StartPosType.Size = new System.Drawing.Size(168, 21);
			this.StartPosType.TabIndex = 12;
			this.StartPosType.Text = "In order";
			this.StartPosType.SelectedIndexChanged += new System.EventHandler(this.StartPosType_SelectedIndexChanged);
			// 
			// MaxUnitsValue
			// 
			this.MaxUnitsValue.Location = new System.Drawing.Point(208, 512);
			this.MaxUnitsValue.Name = "MaxUnitsValue";
			this.MaxUnitsValue.Size = new System.Drawing.Size(40, 23);
			this.MaxUnitsValue.TabIndex = 11;
			this.MaxUnitsValue.Text = "500";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 504);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(48, 32);
			this.label5.TabIndex = 10;
			this.label5.Text = "Max Units";
			// 
			// MaxUnits
			// 
			this.MaxUnits.LargeChange = 100;
			this.MaxUnits.Location = new System.Drawing.Point(56, 504);
			this.MaxUnits.Maximum = 1000;
			this.MaxUnits.Name = "MaxUnits";
			this.MaxUnits.Size = new System.Drawing.Size(152, 42);
			this.MaxUnits.SmallChange = 10;
			this.MaxUnits.TabIndex = 9;
			this.MaxUnits.TickFrequency = 100;
			this.MaxUnits.Value = 500;
			this.MaxUnits.Scroll += new System.EventHandler(this.MaxUnits_Scroll);
			// 
			// EnergyValue
			// 
			this.EnergyValue.Location = new System.Drawing.Point(208, 256);
			this.EnergyValue.Name = "EnergyValue";
			this.EnergyValue.Size = new System.Drawing.Size(40, 23);
			this.EnergyValue.TabIndex = 8;
			this.EnergyValue.Text = "1000";
			// 
			// MetalValue
			// 
			this.MetalValue.Location = new System.Drawing.Point(208, 208);
			this.MetalValue.Name = "MetalValue";
			this.MetalValue.Size = new System.Drawing.Size(40, 23);
			this.MetalValue.TabIndex = 7;
			this.MetalValue.Text = "1000";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 248);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(40, 23);
			this.label1.TabIndex = 6;
			this.label1.Text = "Energy";
			// 
			// Metal
			// 
			this.Metal.Location = new System.Drawing.Point(8, 200);
			this.Metal.Name = "Metal";
			this.Metal.Size = new System.Drawing.Size(32, 23);
			this.Metal.TabIndex = 5;
			this.Metal.Text = "Metal";
			// 
			// EnergyBar
			// 
			this.EnergyBar.LargeChange = 500;
			this.EnergyBar.Location = new System.Drawing.Point(56, 248);
			this.EnergyBar.Maximum = 10000;
			this.EnergyBar.Name = "EnergyBar";
			this.EnergyBar.Size = new System.Drawing.Size(152, 42);
			this.EnergyBar.SmallChange = 100;
			this.EnergyBar.TabIndex = 4;
			this.EnergyBar.TickFrequency = 1000;
			this.EnergyBar.Value = 1000;
			this.EnergyBar.Scroll += new System.EventHandler(this.EnergyBar_Scroll);
			// 
			// MetalBar
			// 
			this.MetalBar.LargeChange = 500;
			this.MetalBar.Location = new System.Drawing.Point(56, 200);
			this.MetalBar.Maximum = 10000;
			this.MetalBar.Name = "MetalBar";
			this.MetalBar.Size = new System.Drawing.Size(152, 42);
			this.MetalBar.SmallChange = 100;
			this.MetalBar.TabIndex = 3;
			this.MetalBar.TickFrequency = 1000;
			this.MetalBar.Value = 1000;
			this.MetalBar.Scroll += new System.EventHandler(this.MetalBar_Scroll);
			// 
			// ButtonStart
			// 
			this.ButtonStart.Enabled = false;
			this.ButtonStart.Location = new System.Drawing.Point(88, 552);
			this.ButtonStart.Name = "ButtonStart";
			this.ButtonStart.TabIndex = 2;
			this.ButtonStart.Text = "Start";
			this.ButtonStart.Click += new System.EventHandler(this.ButtonStart_Click);
			// 
			// Mapname
			// 
			this.Mapname.AutoSize = true;
			this.Mapname.Location = new System.Drawing.Point(112, 168);
			this.Mapname.Name = "Mapname";
			this.Mapname.Size = new System.Drawing.Size(39, 16);
			this.Mapname.TabIndex = 1;
			this.Mapname.Text = "<Map>";
			this.Mapname.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.Mapname.Resize += new System.EventHandler(this.Mapname_Resize);
			// 
			// Minimap
			// 
			this.Minimap.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Minimap.Location = new System.Drawing.Point(40, 8);
			this.Minimap.Name = "Minimap";
			this.Minimap.Size = new System.Drawing.Size(176, 160);
			this.Minimap.TabIndex = 0;
			this.Minimap.TabStop = false;
			this.Minimap.MouseDown += new System.Windows.Forms.MouseEventHandler(this.Minimap_MouseDown);
			// 
			// panel4
			// 
			this.panel4.Controls.Add(this.splitter1);
			this.panel4.Controls.Add(this.panel5);
			this.panel4.Controls.Add(this.listViewEx1);
			this.panel4.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel4.Location = new System.Drawing.Point(0, 0);
			this.panel4.Name = "panel4";
			this.panel4.Size = new System.Drawing.Size(387, 585);
			this.panel4.TabIndex = 3;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 192);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(387, 3);
			this.splitter1.TabIndex = 3;
			this.splitter1.TabStop = false;
			// 
			// panel5
			// 
			this.panel5.Controls.Add(this.splitter3);
			this.panel5.Controls.Add(this.PastMessages);
			this.panel5.Controls.Add(this.TypeMessage);
			this.panel5.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel5.Location = new System.Drawing.Point(0, 192);
			this.panel5.Name = "panel5";
			this.panel5.Size = new System.Drawing.Size(387, 393);
			this.panel5.TabIndex = 2;
			// 
			// splitter3
			// 
			this.splitter3.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter3.Location = new System.Drawing.Point(0, 342);
			this.splitter3.Name = "splitter3";
			this.splitter3.Size = new System.Drawing.Size(387, 3);
			this.splitter3.TabIndex = 3;
			this.splitter3.TabStop = false;
			// 
			// splitter2
			// 
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Right;
			this.splitter2.Location = new System.Drawing.Point(387, 0);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(3, 585);
			this.splitter2.TabIndex = 5;
			this.splitter2.TabStop = false;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																							this.menuOptions,
																																							this.HostOptions});
			// 
			// menuOptions
			// 
			this.menuOptions.Index = 0;
			this.menuOptions.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																								this.menuOptionsSide});
			this.menuOptions.Text = "Leader Options";
			// 
			// menuOptionsSide
			// 
			this.menuOptionsSide.Index = 0;
			this.menuOptionsSide.Text = "Change &Side";
			this.menuOptionsSide.Click += new System.EventHandler(this.menuOptionsSide_Click);
			// 
			// BootPopup
			// 
			this.BootPopup.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																							this.menuItemBoot});
			// 
			// menuItemBoot
			// 
			this.menuItemBoot.Index = 0;
			this.menuItemBoot.Text = "Boot";
			this.menuItemBoot.Click += new System.EventHandler(this.menuItemBoot_Click);
			// 
			// HostOptions
			// 
			this.HostOptions.Index = 1;
			this.HostOptions.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																								this.menuBoot});
			this.HostOptions.Text = "Host Options";
			// 
			// menuBoot
			// 
			this.menuBoot.Index = 0;
			this.menuBoot.Text = "Boot";
			this.menuBoot.Click += new System.EventHandler(this.menuBoot_Click);
			// 
			// BattleRoom
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(640, 585);
			this.Controls.Add(this.panel4);
			this.Controls.Add(this.splitter2);
			this.Controls.Add(this.panel3);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "BattleRoom";
			this.Text = "BattleRoom";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.BattleRoom_Closing);
			this.Load += new System.EventHandler(this.BattleRoom_Load);
			this.panel3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.MaxUnits)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.EnergyBar)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.MetalBar)).EndInit();
			this.panel4.ResumeLayout(false);
			this.panel5.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void BattleRoom_Load(object sender, System.EventArgs e)
		{
			try
			{
				if ( m_bHost )
				{
					BattleServer bs = new BattleServer(listViewEx1, PastMessages);
					m_Handler = bs;
					if ( bs.StartServer(m_Port, m_MaxPlayers) )
						m_Running = true;
					else
					{
						Close();
						throw new Exception("Battle server failed to start");
					}
				}
				else
				{
					BattleClient bc = new BattleClient(listViewEx1, PastMessages);
					m_Handler = bc;
					if ( bc.Start(m_ConnectionManager) )
						m_Running = true;
					else
					{
						Close();
						throw new Exception("Battle client failed to load");
					}
				}
			}
			catch ( Exception ex )
			{
				m_BattleStateManager.Clear(false);
				MessageBox.Show(ex.ToString());
				Close();
			}
		}

		public bool PostMessage( int userid, string data )
		{
			if ( Global.battleRoom.m_BattleStateManager.Members.ContainsKey(userid)  )
			{
				BattleStateManager.BattleMemberInfo ui = (BattleStateManager.BattleMemberInfo)
					Global.battleRoom.m_BattleStateManager.Members[userid];
				PastMessages.AppendText(ui.m_Name.ToString() + ": ");
			}
			else
				PastMessages.AppendText(userid.ToString() + ": ");

			PastMessages.AppendText(data + "\n");
			PastMessages.Update();

			if ( !PastMessages.Focused )
				SendMessage(PastMessages.Handle, Win32.WM_VSCROLL, Win32.SB_BOTTOM, 0);
	
			return true;
		}

		public void CloseBattleRoom()
		{
			if ( m_bHost )
			{
				BattleServer bs = (BattleServer)m_Handler;
				bs.Stop();
				Close();
			}
			else
			{
				BattleClient bc = (BattleClient)m_Handler;
				bc.Stop();
				Close();
			}
		}

		public void Shutdown()
		{
			if ( this.m_bHost )
			{
				BattleServer bs = (BattleServer)m_Handler;
				bs.Stop();
			}
			else
			{
				BattleClient bc = (BattleClient)m_Handler;
				bc.Stop();
			}
			m_Running = false;
		}

		public void PopulateDisabledUnits()
		{
			listBoxDisabled.Items.Clear();
			int count = UnitSync.GetUnitCount();
			if ( count == -1 )
			{
				MessageBox.Show("Error getting unit count");
				return;
			}
			ArrayList disabledBy = new ArrayList();
			for ( int i = 0; i < count; i++ )
			{
				if ( UnitSync.IsUnitDisabled(i) )
				{
					string name = UnitSync.GetFullUnitName(i);
					//int check = listViewEx1.Items.Count;					
					disabledBy.Clear();
					foreach ( DictionaryEntry de in m_BattleStateManager.Members )
					{
						if ( UnitSync.IsUnitDisabledByClient(i, (int)de.Key) )
						{
							BattleStateManager.BattleMemberInfo bmi = (BattleStateManager.BattleMemberInfo)de.Value;
							disabledBy.Add(bmi.m_Name);
						}
					}
					/*
					for ( int j = 0; j < check; j++ )
					{
						if ( UnitSync.IsUnitDisabledByClient(i, j) )
						{
							BattleStateManager.BattleMemberInfo bmi = (BattleStateManager.BattleMemberInfo)Global.battleRoom.m_BattleStateManager.Members[j];
							disabledBy.Add(j.ToString() + "-" + bmi.m_Name);
						}
					}*/
					StringBuilder sb = new StringBuilder();
					sb.AppendFormat("{0} due to", name);
					foreach ( string str in disabledBy )
					{
						sb.AppendFormat(" {0}", str);
					}
					listBoxDisabled.Items.Add(sb.ToString());
				}
			}
		}

		private void MessageSend()
		{
			if ( TypeMessage.Text.Length == 0 )
				return;
			if ( TypeMessage.Text.Length > CONSTANTS.MAXMESSAGELEN )
			{
				MessageBox.Show(string.Format("Message cannot be longer than {0} characters", CONSTANTS.MAXMESSAGELEN));
				TypeMessage.Clear();
				return;
			}
			if ( this.m_bHost )
			{
				((BattleServer)m_Handler).SendMessage(m_ConnID, TypeMessage.Text);
				((BattleServer)m_Handler).PostMessage(m_ConnID, TypeMessage.Text);
				TypeMessage.Clear();
			}
			else
			{
				((BattleClient)m_Handler).SendMessage(m_ConnID, TypeMessage.Text);
				TypeMessage.Clear();
			}
		}

		private void BattleRoom_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			try
			{
				Shutdown();
				/*
				// default is to notify the main form that the battle room has closed
				if ( m_Running )
					Shutdown();
					*/
			}
			catch ( SocketException )
			{
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void TypeMessage_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if ( e.Modifiers != Keys.Shift && e.KeyCode == Keys.Enter )
			{
				MessageSend();
				e.Handled = true;
			}
		}

		private void Mapname_Resize(object sender, System.EventArgs e)
		{
			Label label = (Label)sender;
			label.Location = new Point((panel3.Width-label.Width)/2, label.Location.Y);
		}

		public void StartBattle()
		{
			try
			{
				if ( !CreateStartScript("script.txt") )
				{
					MessageBox.Show("Failed to create start script");
					return;
				}
				
				if ( m_bHost )
				{
					if (  Global.connMan != null )
					{
						byte[] msg = new byte[2];
						msg[0] = (byte)PACKETS.PACK_BATTLEPROGRESS;
						msg[1] = 1;
						Global.connMan.Send(msg);
					}
					BattleServer bs = (BattleServer)m_Handler;
					bs.UpdateBattleProgress(true);
				}

				ThreadStart ts = new ThreadStart(SpawnSpring);
				System.Threading.Thread launchSpring = new Thread(ts);
				launchSpring.Start();				
			}
			catch ( Exception ex )
			{
				ex.ToString();
			}
		}

		private void SpawnSpring()
		{
			try
			{
				Process spring = Process.Start("spring.exe", "script.txt");
				spring.WaitForExit();
				if ( m_bHost )
				{
					if ( Global.connMan != null )
					{
						byte[] msg = new byte[2];
						msg[0] = (byte)PACKETS.PACK_BATTLEPROGRESS;
						msg[1] = 0;
						Global.connMan.Send(msg);
					}
					BattleServer bs = (BattleServer)m_Handler;
					bs.UpdateBattleProgress(false);
				}
			}
			catch ( SocketException )
			{
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void ButtonStart_Click(object sender, System.EventArgs e)
		{
			// here is where spring is actually started... YES!
			try
			{
				foreach ( DictionaryEntry de in this.m_BattleStateManager.Members )
				{
					BattleStateManager.BattleMemberInfo bmi = (BattleStateManager.BattleMemberInfo)de.Value;
					if ( !bmi.m_Synced )
					{
						MessageBox.Show("Cannot start until everyone is synced");
						return;
					}
				}
				StartBattle();
				BattleServer bs = (BattleServer)m_Handler;
				bs.SendStartBattle();
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private bool CreateStartScript( string filename )
		{
			StreamWriter sw = File.CreateText(filename);
			try
			{
				Hashtable members = new Hashtable();
				Hashtable teams = new Hashtable();
				Hashtable allyteams = new Hashtable();

				int selfid = -1;

				int index = 0;

				for ( int i = 0; i < m_BattleStateManager.OrderedMembers.Count; i++ )
				{
					BattleStateManager.BattleMemberInfo bmi = (BattleStateManager.BattleMemberInfo)m_BattleStateManager.OrderedMembers[i];
					members.Add(bmi.m_ConnID, index);
					if ( bmi.m_ConnID == m_ConnID )
						selfid = index;
					index++;
				}

				byte ind = 0;
				// we go through the list backwards because of the way hashtable stores its data internally
				for ( int i = m_BattleStateManager.Teams.Length-1; i >= 0; i-- )
				{
					BattleStateManager.TeamInfo ti = m_BattleStateManager.Teams[i];
					if ( ti.m_Members.Count == 0 )
						continue;
					teams.Add(ti.m_TeamID, ind);
					ind++;
				}
				ind = 0;
				for ( int i = m_BattleStateManager.AllyTeams.Length-1; i >= 0; i-- )
				{
					BattleStateManager.AllyTeamInfo ati = m_BattleStateManager.AllyTeams[i];
					if ( ati.m_Members.Count == 0 )
						continue;
					BattleStateManager.TeamInfo ti = (BattleStateManager.TeamInfo)ati.m_Members[ati.m_Members.Count-1];
					if ( ti.m_Members.Count == 0 )
						continue;
					allyteams.Add(ati.m_AllyTeamID, ind);
					ind++;
				}

				
				sw.WriteLine("[GAME]");
				sw.WriteLine("{");
				sw.WriteLine(string.Format("\tMapname={0}.smf;", this.Mapname.Text));
				sw.WriteLine(string.Format("\tStartMetal={0};", m_BattleStateManager.metal));
				sw.WriteLine(string.Format("\tStartEnergy={0};", m_BattleStateManager.energy));
				sw.WriteLine(string.Format("\tMaxUnits={0};", m_BattleStateManager.maxUnits));
				sw.WriteLine(string.Format("\tStartPosType={0};", m_BattleStateManager.startPosType));
				sw.WriteLine(string.Format("\tGameMode={0};", m_BattleStateManager.gameGoalType));

				int idx = GetPrimaryModIndex(Global.SelectedMod);
				string baseMod = GetPrimaryModArchive(idx);
				sw.WriteLine(string.Format("\tGameType={0};", baseMod));

				if ( m_bHost )
				{
					sw.WriteLine("\thostip=127.0.0.1;");
					sw.WriteLine(string.Format("\thostport={0};", m_Port));
				}
				else
				{
					string[] address = m_ConnectionManager.socket.RemoteEndPoint.ToString().Split(":".ToCharArray(), 2);
					sw.WriteLine(string.Format("\thostip={0};", address[0]));
					int port = Convert.ToInt32(address[1]);
					sw.WriteLine(string.Format("\thostport={0};", port));
				}
				sw.WriteLine(string.Format("\tMyPlayerNum={0};", selfid));
				sw.WriteLine(string.Format("\tNumPlayers={0};", m_BattleStateManager.Members.Count));
				sw.WriteLine(string.Format("\tNumTeams={0};", teams.Count));
				sw.WriteLine(string.Format("\tNumAllyTeams={0};", allyteams.Count));

				IDictionaryEnumerator ide = members.GetEnumerator();
				while ( ide.MoveNext() )
				{
					index = (int)ide.Key;
					int id = (int)ide.Value;
					BattleStateManager.BattleMemberInfo bmi = (BattleStateManager.BattleMemberInfo)m_BattleStateManager.Members[index];
					sw.WriteLine(string.Format("\t[PLAYER{0}]", id));
					sw.WriteLine("\t{");
					sw.WriteLine(string.Format("\t\tname={0};", bmi.m_Name));
					if ( bmi.m_bSpectator )
						sw.WriteLine(string.Format("\t\tSpectator={0};", 1));
					else
					{
						sw.WriteLine(string.Format("\t\tSpectator={0};", 0));
						sw.WriteLine(string.Format("\t\tteam={0};", (byte)teams[(byte)bmi.m_TeamID]));
					}
					sw.WriteLine("\t}");
				}

				ide = teams.GetEnumerator();
				while ( ide.MoveNext() )
				{
					ind = (byte)ide.Key;
					byte id = (byte)ide.Value;
					BattleStateManager.TeamInfo ti = (BattleStateManager.TeamInfo)m_BattleStateManager.Teams[ind];
					sw.WriteLine(string.Format("\t[TEAM{0}]", id));
					sw.WriteLine("\t{");
					sw.WriteLine(string.Format("\t\tTeamLeader={0};", (int)members[((BattleStateManager.BattleMemberInfo)ti.m_Members[0]).m_ID]));
					sw.WriteLine(string.Format("\t\tAllyTeam={0};", (byte)allyteams[ti.m_AllyTeamID]));
					sw.WriteLine(string.Format("\t\tColor={0};", (byte)ti.m_TeamID));
					// this needs to be changed to a variable
					if ( ti.m_Side == BattleStateManager.SIDE.ARM )
						sw.WriteLine(string.Format("\t\tSide={0};", "Arm"));
					else
						sw.WriteLine(string.Format("\t\tSide={0};", "Core"));
					sw.WriteLine(string.Format("\t\tHandicap={0};", 0));
					sw.WriteLine("\t}");
				}

				ide = allyteams.GetEnumerator();

				while ( ide.MoveNext() )
				{
					ind = (byte)ide.Key;
					byte id = (byte)ide.Value;
					BattleStateManager.AllyTeamInfo ati = (BattleStateManager.AllyTeamInfo)m_BattleStateManager.AllyTeams[ind];
					sw.WriteLine(string.Format("\t[ALLYTEAM{0}]", id));
					sw.WriteLine("\t{");
					sw.WriteLine(string.Format("\t\tNumAllies={0};", ati.m_AlliedTo.Count));
					for ( int i = 0; i < ati.m_AlliedTo.Count; i++ )
					{
						if ( teams.ContainsKey((byte)ati.m_AlliedTo[i]))
							sw.WriteLine(string.Format("\t\tAlly{0}={1};", i, (byte)teams[(byte)ati.m_AlliedTo[i]]));
					}
					sw.WriteLine("\t}");
				}

				int numres = listBoxDisabled.Items.Count;
				int units = UnitSync.GetUnitCount();
				sw.WriteLine(string.Format("\tNumRestrictions={0};", numres));
				sw.WriteLine("\t[RESTRICT]");
				sw.WriteLine("\t{");
				int j = 0;
				for ( int i = 0; i < units; i++ )
				{
					if ( UnitSync.IsUnitDisabled(i) )
					{
						sw.WriteLine(string.Format("\t\tUnit{0}={1};", j, UnitSync.GetUnitName(i)));
						sw.WriteLine(string.Format("\t\tLimit{0}=0;", j++));
					}
				}
				sw.WriteLine("\t}");
				sw.WriteLine("}");
				
				return true;
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
				return false;
			}
			finally 
			{
				sw.Flush();
				sw.Close();
			}
		}

		private void menuOptionsSide_Click(object sender, System.EventArgs e)
		{
			try
			{
				BattleStateManager.BattleMemberInfo bmi = (BattleStateManager.BattleMemberInfo)m_BattleStateManager.Members[m_ConnID];
				if ( bmi != null && bmi.m_InternalID == 0 )
				{
					BattleStateManager.TeamInfo ti = m_BattleStateManager.Teams[(byte)bmi.m_TeamID];
					if ( m_bHost )
					{
						BattleServer bs = (BattleServer)m_Handler;
						if ( ti.m_Side == BattleStateManager.SIDE.ARM )
						{
							bs.SendChangeSide((byte)bmi.m_TeamID, (byte)BattleStateManager.SIDE.CORE);
							Changeside((byte)bmi.m_TeamID, (byte)BattleStateManager.SIDE.CORE);
						}
						else
						{
							bs.SendChangeSide((byte)bmi.m_TeamID, (byte)BattleStateManager.SIDE.ARM);
							Changeside((byte)bmi.m_TeamID, (byte)BattleStateManager.SIDE.ARM);
						}
					}
					else
					{
						BattleClient bc = (BattleClient)m_Handler;
						if ( ti.m_Side == BattleStateManager.SIDE.ARM )
							bc.SendChangeSide((byte)BattleStateManager.SIDE.CORE);
						else
							bc.SendChangeSide((byte)BattleStateManager.SIDE.ARM);
					}
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void Minimap_Click(object sender, System.EventArgs e)
		{
			
			m_mapSelector.Show();
			m_mapSelector.Location = new Point(this.Location.X+this.Width, this.Location.Y);
			m_mapSelector.Focus();
		}

		private void Mapname_Click(object sender, System.EventArgs e)
		{
			m_mapSelector.Show();
			m_mapSelector.Location = new Point(this.Location.X+this.Width, this.Location.Y);
			m_mapSelector.Focus();
		}

		private void Minimap_ImageChanged(object sender)
		{
			if ( m_bHost )
			{
				BattleServer bs = (BattleServer)m_Handler;
				if ( bs != null )
					bs.SendChangeMap(Mapname.Text);
			}
		}

		private void panel3_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
		
		}

		private void MetalBar_Scroll(object sender, System.EventArgs e)
		{
			if(m_bHost)
				ChangeResources(true,MetalBar.Value,EnergyBar.Value);
			else
				MetalBar.Value=m_BattleStateManager.metal;
			MetalValue.Text=Convert.ToString(MetalBar.Value);
		}

		private void EnergyBar_Scroll(object sender, System.EventArgs e)
		{
			if(m_bHost)
				ChangeResources(true,MetalBar.Value,EnergyBar.Value);		
			else
				EnergyBar.Value=m_BattleStateManager.energy;
			EnergyValue.Text=Convert.ToString(EnergyBar.Value);
		}

		private void MaxUnits_Scroll(object sender, System.EventArgs e)
		{
			if(m_bHost)
				ChangeMaxUnits(true,MaxUnits.Value);
			else
				MaxUnits.Value=m_BattleStateManager.maxUnits;		
			MaxUnitsValue.Text=Convert.ToString(MaxUnits.Value);
		}

		private void Minimap_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if ( e.Button == MouseButtons.Right )
			{
				// e.X has the x coordinate relative to the controls position, and e.Y has the y 
			}
		}

		private void StartPosType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(m_bHost)
			{
				int type=StartPosType.SelectedIndex;
				ChangeStartPosType(true,type);
			}
		}

		private void GameEndType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(m_bHost)
			{
				int type=GameEndType.SelectedIndex;
				ChangeGoalType(true,type);
			}
		
		}

		private void BootUserHelper(BattleStateManager.BattleMemberInfo bmi)
		{
			BattleServer bs = (BattleServer)m_Handler;
			bs.BootUser(bmi);
		}

		private void menuItemBoot_Click(object sender, System.EventArgs e)
		{
			try
			{
				ListViewItem lvi = listViewEx1.SelectedItems[0];
				IDictionaryEnumerator ide = Global.battleRoom.m_BattleStateManager.Members.GetEnumerator();
				while ( ide.MoveNext() )
				{
					BattleStateManager.BattleMemberInfo bmi = (BattleStateManager.BattleMemberInfo)ide.Value;
					if ( object.Equals(bmi.m_lvi, lvi) )
					{
						// this is a bug in .NET.  If boot user is called directly, an exception is thrown since
						// it doesn't like an lvi being removed until this call is completed.  so just call it on the
						// same thread after this function terminates
						Global.PrimaryForm.BeginInvoke(BootUser, new object[] {bmi});
						return;
					}
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void listViewEx1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if ( e.Button == MouseButtons.Right && m_bHost && listViewEx1.SelectedIndices.Count > 0 )
			{
				if ( listViewEx1.SelectedIndices[0] != 0 )
				{
					BootPopup.Show(listViewEx1, new Point(e.X,e.Y));
				}
			}
		}

		private void menuBoot_Click(object sender, System.EventArgs e)
		{
			try
			{
				ListViewItem lvi = listViewEx1.SelectedItems[0];
				IDictionaryEnumerator ide = Global.battleRoom.m_BattleStateManager.Members.GetEnumerator();
				while ( ide.MoveNext() )
				{
					BattleStateManager.BattleMemberInfo bmi = (BattleStateManager.BattleMemberInfo)ide.Value;
					if ( object.Equals(bmi.m_lvi, lvi) )
					{
						BattleServer bs = (BattleServer)m_Handler;
						bs.BootUser(bmi);
						return;
					}
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		
		}
	}
}